"""
A thug test enemy.
"""

import pygame, math
from pygame.locals import *
from my_sprite import my_sprite

class thug(my_sprite):
    def __init__(self, game, loc, initial_facing, initial_state):
        my_sprite.__init__(self, game, loc, "Thug", initial_facing, initial_state, False, True)
        
    def update_state(self):
        """Update the thug's state."""
        if self.state == "Paralysis (DEBUG)":
            return
        
        if self.what_under: 
            # Let the thug always try to move when on the ground
            if self.state == "Stand":
                self.set_state("Run")
                if self.facing == 0:
                    self.vel[0] = 0.5
                else:
                    self.vel[0] = -0.5
                    
            # Turn around if running (and bumping) into another sprite
            if self.vel[0] == 0 and self.state == "Run":
#                self.set_state("Stand")
                if self.sprite_bump:
                    self.facing = (self.facing + 1) % 2
                    self.vel[0] = -self.vel[0]

            # Have him turn around at the edges of whatever surface he is walking on
            if self.check_edge():
                self.facing = (self.facing + 1) % 2
                self.vel[0] = -self.vel[0]

    def check_edge(self):
        if self.facing == 0:
            t_x = int(self.r.x + self.r.w) // self.game.t.tile_size
        else:
            t_x = int(self.r.x) // self.game.t.tile_size
        t_y = int(self.r.y + self.r.h) // self.game.t.tile_size

        i = self.game.t.map[t_y][t_x]
        t = self.game.t.tileset[i]

        return (i == -1 or t.obstruction == "None")
